import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;


class Element extends JPanel implements ActionListener{
	private static final long serialVersionUID = -1154451023773719212L;
	JPanel top = new JPanel(new GridLayout(1,2));
	JScrollPane sp = new JScrollPane();
	JPanel display = new JPanel();
	JPanel bot = new JPanel(new GridLayout(1,2));
	
	JTextField field[] = new JTextField[100];
    JButton but[] = new JButton[100];
	JLabel inst = new JLabel("instructions");
	JLabel fill = new JLabel("");
    
    JButton save = new JButton("save");
    JButton plus = new JButton("Add more Elements");
    
    GridBagConstraints gbc = new GridBagConstraints();
    GridBagConstraints gbc2 = new GridBagConstraints();
    //GridBagConstraints gbc3 = new GridBagConstraints();
    
    File f;
    File fnew;

    globalvar g;
    int numele = 0;
    int count = 0;
    
	public Element(){
        setLayout(new BorderLayout());
		//display.setLayout(new GridLayout(10,1));
		display.setLayout(new GridBagLayout());
    
        gbc.fill = GridBagConstraints.HORIZONTAL;
        gbc2.fill = GridBagConstraints.HORIZONTAL;
        //gbc3.fill = GridBagConstraints.HORIZONTAL;
        gbc.weighty = 0.1;
        
        for(int i = 0; i<10; i++){
            gbc.ipady = 10;
            gbc.weightx = 0.8;
            gbc.gridx = 0;
            gbc.gridy = i;
            field[i] = new JTextField("");
            display.add(field[i],gbc);
            
            gbc2.ipady = 10;
            gbc2.gridx = 1;
            gbc2.gridy = i;
            but[i] = new JButton("edit");
            but[i].addActionListener(this);
            display.add(but[i],gbc2);
            numele++;
        }
        save.addActionListener(this);
		plus.addActionListener(this);

        
		sp.getViewport().add(display);
		top.add(inst);
        top.add(plus);
		bot.add(fill);
        bot.add(save);
        
		add(top, BorderLayout.NORTH);
		add(sp, BorderLayout.CENTER);
        add(bot, BorderLayout.SOUTH);
	}
    public void updateGlobe(globalvar globe){
		g = globe;
	}
	public void updateFile(File f2){
		//System.out.println("updates f in element");
		f = f2;
	}
    public void actionPerformed(ActionEvent e){
        if (e.getSource() == plus){
            System.out.println(numele+" add new element");
            //System.out.println("button hit");
            gbc.gridy = numele;
            field[numele] = new JTextField();
            display.add(field[numele],gbc);
            
            gbc2.gridy = numele;
            but[numele] = new JButton("edit");
            but[numele].addActionListener(this);
            display.add(but[numele],gbc2);
            numele++;
            revalidate();
        }
        for(int i = 0;i<numele;i++){
            
            if (e.getSource() == but[i]){
                try{
                    openBudget(i);
                }catch(IOException ie){
                    System.out.println("error in open budget");
                }
            }
        }
        if (e.getSource() == save){
            try{
                writeFile();
            }catch(IOException ie){
                System.out.println("error");
            }
        }
    }
    public void openBudget(int j) throws FileNotFoundException, IOException
    {
        if(!field[j].getText().equals("")){
            String fname = g.getDirectory()+"/Element/";
            boolean success = (new File(fname)).mkdir();
            new Budgetele(field[j].getText(),g);           
        }else
            System.out.println("field is empty");
    }
    public void writeFile() throws FileNotFoundException, IOException 
	{
		if (f == null) {
            System.out.println("f is null");
		}
		else if (!f.exists()) {
			throw new FileNotFoundException ("File does not exist: " + f);
		}
		else if (!f.isFile()) {
			throw new IllegalArgumentException("Should not be a directory: " + f);
		}
		else if (!f.canWrite()) {
			throw new IllegalArgumentException("File cannot be written: " + f);
		}else{
			//Writer output = new BufferedWriter(new FileWriter(f));
            RandomAccessFile output = new RandomAccessFile(f,"rw");
			try {
                for(int i = 0; i<9; i++){
                    output.readLine();
                }
                for(int i = 0; i<numele;i++){
                	if(!field[i].getText().equals("")){
                		String temp = field[i].getText()+"\n";
                    	output.writeBytes(temp);
                	}
                }
			}
			finally {
                output.writeBytes("");
				output.close();
			}
		}
        g.upload(f);
	}
    public void readFile(){
        try{
            BufferedReader input =  new BufferedReader(new FileReader(f));
            try{
                String line = null;
                //RandomAccessFile rand = new RandomAccessFile(f,"r"); 
                while ((line = input.readLine()) != null){
                    if(count>=9 && (line.equals(""))){
                        count--;
                        continue;
                    }
                    if(count <9 && line.equals("")){
                        continue;
                    }
                    if(count>=9 && count<=18){
                        //System.out.println(line);
                        field[count-9].setText(""+line);
                        //but[count-7].addActionListener(this);
                        revalidate();
                    }else if(count>18){
                        gbc.gridy = numele;
                        field[numele] = new JTextField(""+line);
                        display.add(field[numele],gbc);
                        
                        gbc2.gridy = numele;
                        but[numele] = new JButton("edit");
                        but[numele].addActionListener(this);
                        display.add(but[numele],gbc2);
                        numele++;
                        revalidate();
                    }
                    count++;
                }
            }finally{
                input.close();
                count = 0;
            }
        }catch (IOException ioe){
            ioe.printStackTrace();
        }
    }
}