import javax.swing.*;

import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.text.*;
import java.beans.PropertyChangeListener;
import java.beans.PropertyChangeEvent;

class SetDefault extends JFrame implements ActionListener, PropertyChangeListener{
	private static final long serialVersionUID = -1154451023773719212L;
	File f;
    JPanel main = new JPanel(new GridLayout(4,2));
    JPanel bot = new JPanel(new GridLayout(1,2));
    JPanel carbongrid = new JPanel(new GridLayout(5,2));
    JLabel empty = new JLabel("");
    JButton apply = new JButton("apply");
    JButton cancel = new JButton("cancel");
    JButton db = new JButton("Edit Database");
    
    //labels
    JLabel tax_label = new JLabel("Tax");
    JLabel currency_label = new JLabel("Currency");
    JLabel database_label = new JLabel("Edit Database");
    JLabel carbon_label = new JLabel("Carbon Offset");
    
    //respective input
    JFormattedTextField tax_field;
    JTextField currency_field = new JTextField();
    JFormattedTextField carbon_field;
    
    globalvar g;
    
    double ptotal = 0;
    double sum = 0;
    double num = 0;
    double tax;
    int row = 0;
    int col = 0;
    
    public SetDefault(globalvar globe){
        super("Defaults");
        tax_field = new JFormattedTextField(NumberFormat.getNumberInstance());
        carbon_field = new JFormattedTextField(NumberFormat.getNumberInstance());

        g = globe;
        tax_field.setValue(g.getTax());
        currency_field.setText(g.getCurrency());
        
        main.add(tax_label);
        main.add(tax_field);
        main.add(currency_label);
        main.add(currency_field);
        main.add(carbon_label);
        main.add(carbon_field);
        main.add(database_label);
        main.add(db);
        apply.addActionListener(this);
        bot.add(empty);
        bot.add(apply);
        setLayout(new BorderLayout());
        add(main, BorderLayout.CENTER);
        add(bot, BorderLayout.SOUTH);
        pack();
		setSize(500,500);
		setResizable(false);
		setVisible(true);
    }
    public void updateGlobe(globalvar globe){
		g = globe;
	}
	
	public void actionPerformed(ActionEvent e)
	{
		if (e.getSource() == apply){
			//g.setTax((Double)tax_field.getValue());
			g.setTax(Double.parseDouble((String)tax_field.getValue()));
			g.setCurrency(currency_field.getText());
			try{
				writeFile();
			}catch(IOException ioe){
				System.out.println("io exception");
			}
		}
	}
    public void propertyChange(PropertyChangeEvent e){
        
    }
	public void writeFile() throws FileNotFoundException, IOException {
		if (f == null) {
            System.out.println("f is null");
		}
		else if (!f.exists()) {
			throw new FileNotFoundException ("File does not exist: " + f);
		}
		else if (!f.isFile()) {
			throw new IllegalArgumentException("Should not be a directory: " + f);
		}
		else if (!f.canWrite()) {
			throw new IllegalArgumentException("File cannot be written: " + f);
		}else{
			//Writer output = new BufferedWriter(new FileWriter(f));
            RandomAccessFile output = new RandomAccessFile(f,"rw");
			try {
                for(int i = 0; i<7; i++){
                    output.readLine();
                }
                output.writeBytes(tax_field.getValue()+"\n");
                output.writeBytes(currency_field.getText()+"\n");
			}
			finally {
				output.close();
			}
		}
	}
    public void readFile(){
    	try{
            BufferedReader input =  new BufferedReader(new FileReader(f));
            try{
            	int count = 0;
                String line = null;
                while ((line = input.readLine()) != null){
                    if(count<7){
                        continue;
                    }else if(count==7){
                    	tax_field.setValue(Double.parseDouble(line));
                    }else if(count==8){
                    	currency_field.setText(line);
                    }
                    count++;
                }
            }finally{
                input.close();
            }
        }catch (IOException ioe){
            ioe.printStackTrace();
        }
    }
}