import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.border.EmptyBorder;
import java.io.*;
import javax.swing.filechooser.*;

public class Welcome extends JPanel implements ActionListener{
	private static final long serialVersionUID = -1154451023773719212L;
	JButton newBudget = new JButton("New Budget");
	JButton openBudget = new JButton("Open Budget");
	JButton copyBudget = new JButton("Copy Budget");
	JButton setDefaults = new JButton("Set Defaults");
	
	// for ease of use with gridlayout
	JPanel info = new JPanel();
	JPanel buttons = new JPanel(new GridLayout(4,1));
	JPanel sponsors = new JPanel();

	JLabel infoText = new JLabel("<html><B> Welcome</B></html>");
	JLabel infoText2 = new JLabel(
	"<html><P>This tool is free to use and can help make green choices!"+
	"<P>To start a New Budget, simply click new budget. If you"+
	"<P>already have a budget, select the file in Open Budget."+
	"<P>If you want to work off a copy of a budget, select Copy "+
	"<P>Budget. But don't forget to set your initial defaults!</html>");
	JLabel sponsorText = new JLabel(
    "<html>This project builds upon the ratings system, materials descriptions "+
    "<P>and presentation of Mo`olelo's Green Theater Choices Toolkit created "+
    "<P>by Mo`olelo Performing Arts Company (www.moolelo.net) and Brown "+
    "<P>and Wilmanns Environmental, LLC (www.bw-environmental.com). All<P>"+
    "carbon measurements found in this project is available on the ICE <P>"+
    "Database created by the University of Bath."+
    "<P>Credits:"+
    "<P>Key Developers: James McKernan & Peter McKinnon"+ 
    "<P>Software written by: Niken Goswami"+
    "<P>Special Thanks to: David Fehley & Bob Usdin<P></html>");
	JTabbedPane jtp;
	
	//create a JFileChooser
	JFileChooser fc = new JFileChooser();
	File f;
	
	globalvar g;
	
	public Welcome(JTabbedPane jtpc){
		setLayout(new GridLayout(3,1));
		jtp = jtpc;
		newBudget.addActionListener(this);
		openBudget.addActionListener(this);
		copyBudget.addActionListener(this);
		setDefaults.addActionListener(this);
		
		infoText.setFont(new Font("Serif",Font.PLAIN,36));
		info.add(infoText);
		info.add(infoText2);
		// add buttons to buttons panel
		buttons.setBorder(new EmptyBorder(5,70,5,70));
		buttons.add(newBudget);
		buttons.add(openBudget);
		buttons.add(copyBudget);
		buttons.add(setDefaults);
		
		sponsors.setBorder(new EmptyBorder(20,0,0,0));
		sponsors.add(sponsorText);
		// add panels to main panel
		add(info);
		add(buttons);
		add(sponsors);
	}
	public void updateGlobe(globalvar globe){
		g = globe;
	}
	public void updateFile(File f2){
		//System.out.println("updates f in welcome");
		f = f2;
	}
	
	public void actionPerformed(ActionEvent e)
	{
		if (e.getSource() == newBudget){
			jtp.setEnabledAt(1,true);
			jtp.setSelectedIndex(1);
		}
		if (e.getSource() == openBudget) {
			int returnVal = fc.showOpenDialog(this);
			f = fc.getSelectedFile();
			if(f==null){
			}else{
				if(f.exists()){
                    try{
                        jtp.setEnabledAt(1,true);
                        jtp.setEnabledAt(2,true);
                        jtp.setEnabledAt(3,true);
                        jtp.setEnabledAt(4,true);
                        jtp.setEnabledAt(5,true);
                        g.upload(f);
                        g.readFileDefaults();
                        g.updateFilename(f.getName());
                    }catch(NullPointerException n){
                        System.out.println("w: g is null");
                    }
                }
			}
        }
        if (e.getSource() == setDefaults){
            new SetDefault(g);
        }
	}
}
